ad_library {

    site node / apm integration procs

    @author arjun (arjun@openforce.net)
    @author yon (yon@openforce.net)
    @creation-date 2002-07-10
    @version $Id: site-node-apm-integration-procs.tcl,v 1.1 2002/07/25 18:46:52 rmello Exp $

}

namespace eval site_node_apm_integration {

    ad_proc -public new_site_node_and_package {
        {-name:required}
        {-parent_id:required}
        {-package_key:required}
        {-instance_name:required}
        {-context_id:required}
    } {
        create site node, instantiate package, mount package at new site node
    } {
        set node_id [site_node::new -name $name -parent_id $parent_id]

        set package_id [apm_package_create_instance $instance_name $context_id $package_key]

        site_node::mount -node_id $node_id -object_id $package_id

        site_node::update_cache -node_id $node_id

        # call post instantiation proc for the package
        apm_package_call_post_instantiation_proc $package_id $package_key

        return $package_id
    }

    ad_proc -public get_child_package_id {
        {-package_id ""}
        {-package_key:required}
    } {
        get the package_id of package_key that is mounted directly under
        package_id. returns empty string if not found.
    } {
        if {[empty_string_p $package_id]} {
            set package_id [ad_conn package_id]
        }

        return [db_string select_child_package_id {} -default ""]
    }

    ad_proc -public child_package_exists_p {
        {-package_id ""}
        {-package_key:required}
    } {
        Returns 1 if there exists a child package with the given package_key, 
        or 0 if not.
    } {
        set child_package_id [get_child_package_id \
            -package_id $package_id \
            -package_key $package_key
        ]

        if {[empty_string_p $child_package_id]} {
            return 0
        } else {
            return 1 
        }
    }

}
